# frozen_string_literal: true

# Copyright 2020 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Auto-generated by gapic-generator-ruby. DO NOT EDIT!


module Google
  module Api
    # `Backend` defines the backend configuration for a service.
    # @!attribute [rw] rules
    #   @return [::Array<::Google::Api::BackendRule>]
    #     A list of API backend rules that apply to individual API methods.
    #
    #     **NOTE:** All service configuration rules follow "last one wins" order.
    class Backend
      include ::Google::Protobuf::MessageExts
      extend ::Google::Protobuf::MessageExts::ClassMethods
    end

    # A backend rule provides configuration for an individual API element.
    # @!attribute [rw] selector
    #   @return [::String]
    #     Selects the methods to which this rule applies.
    #
    #     Refer to {::Google::Api::DocumentationRule#selector selector} for syntax details.
    # @!attribute [rw] address
    #   @return [::String]
    #     The address of the API backend.
    # @!attribute [rw] deadline
    #   @return [::Float]
    #     The number of seconds to wait for a response from a request.  The default
    #     deadline for gRPC is infinite (no deadline) and HTTP requests is 5 seconds.
    # @!attribute [rw] min_deadline
    #   @return [::Float]
    #     Minimum deadline in seconds needed for this method. Calls having deadline
    #     value lower than this will be rejected.
    class BackendRule
      include ::Google::Protobuf::MessageExts
      extend ::Google::Protobuf::MessageExts::ClassMethods
    end
  end
end
